
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw3d/Command.h>
#include <X11/Xaw3d/Text.h>
#include <X11/Xaw3d/Form.h>
#include <X11/Xaw3d/AsciiText.h>
#include <X11/Xaw3d/AsciiSrc.h>
#include <X11/Shell.h>
#include <X11/xv/xvCore.h>
#include <X11/xv/xvBasicBitmap.h>
#include <X11/xv/xvFont.h>
#include <X11/xv/xvRegion.h>
#include <X11/xv/xvGC.h>
#include <X11/xv/xvGraphic.h>
#include <X11/xv/xvForm.h>
#include <X11/xv/xvWindow.h>
#include <X11/xv/xvButton.h>
#include <X11/xv/xvEditField.h>
#include <X11/xv/xvEditWindow.h>

// -----------------------------------------------------------------

xvEditWindow::xvEditWindow()
{
}
 
// -----------------------------------------------------------------

xvEditWindow::xvEditWindow(xvCore & parent, String header, XawTextEditType mode, 
		String datasource,Dimension xsize, Dimension ysize,
		XtCallbackProc ok_call, XtCallbackProc cancel_call, String client)
{
	init(parent, header, mode, datasource, xsize, ysize, ok_call, cancel_call, client);
}

// =================================================================

xvEditWindow::~xvEditWindow()
{
}
 
// -----------------------------------------------------------------

void xvEditWindow::init(xvCore & parent, String header, XawTextEditType mode, 
		String datasource, Dimension xsize, Dimension ysize,
		XtCallbackProc ok_call, XtCallbackProc cancel_call, String client)
{
	xvWindow::init(header, "xvEditWindow", parent);
	xvWindow::SetBackground("gray70");

	editform.init("editform", xvWindow::ID());
	editform.SetBackground("gray70");
	
	xvEditField::init("editarea", editform, mode, ysize, xsize,
		XawAsciiString, datasource, FALSE, NULL, NULL);
	xvEditField::Wrap(XawtextWrapLine);
	xvEditField::AutoWrap(TRUE);
	
	editok.init("OK", editform, ok_call, client);
	editok.SetWidth(80);
	editok.SetShadowWidth(4);
	editok.SetDistance(xsize/2-100, ysize+20);
	editok.SetBeNiceToColormap(FALSE);

	editcancel.init("Cancel", editform, cancel_call, client);
	editcancel.SetWidth(80);
	editcancel.SetShadowWidth(4);
	editcancel.SetDistance(xsize/2+20, ysize+20);
	editcancel.SetBeNiceToColormap(FALSE);
}

// -----------------------------------------------------------------
	