
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/xv/xvCore.h>
#include <X11/xv/xvFont.h>
#include <X11/xv/xvBasicBitmap.h>
#include <X11/xv/xvLabel.h>
#include <X11/xv/xvTimer.h>
#include <X11/xv/timer.xbm>

// ---------------------------------------------

xvTimer::xvTimer()
{
}

// ---------------------------------------------

xvTimer::xvTimer(String name, xvCore & parent, unsigned long timed, 
				XtTimerCallbackProc tcall, Boolean visible)
{
	init(name, parent, timed, tcall);
}

// ---------------------------------------------

xvTimer::~xvTimer()
{
}

// ---------------------------------------------

void xvTimer::init(String name, xvCore & parent, unsigned long timed, XtTimerCallbackProc tcall, Boolean visible)
{
	cdata=(XtPointer) name;
	app_cxt=XtWidgetToApplicationContext(parent.ID());
	proc=tcall;
	interval=timed;

	if (visible) {
		xvLabel::init(name, parent.ID());
		xvLabel::SetBitmapInfo(timer_bits, timer_width, timer_height, XtNbitmap);
	}
	if (timed != 0L) Reset();
}

// ---------------------------------------

void xvTimer::Reset()
{
	intid=XtAppAddTimeOut(app_cxt, interval, proc, cdata);
}

// ----------------------------------------

void xvTimer::Reset(unsigned long timed)
{
	interval=timed;
	intid=XtAppAddTimeOut(app_cxt, interval, proc, cdata);
}

// ----------------------------------------
	