
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	Grid Segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>

// ---------------------------------------------
// Local data

// ---------------------------------------------
// local forward function declares

// --------------------------------------------
// Callbacks

void func_grid_ok(Widget aw, XtPointer client, XtPointer call)
{
	char *vx, *vy;
	int tmpx, tmpy;
	vx=xval.ReturnString(vx);
	vy=yval.ReturnString(vy);
	sscanf(vx, "%d", &tmpx);
	sscanf(vy, "%d", &tmpy);
	if (tmpx <=0) tmpx=10;
	if (tmpy <=0) tmpy=10;
	gridX=tmpx;
	gridY=tmpy;
	xvisGrid.Close();
	for (int i=0; i<nobject; i++)
		if (objects[i].object_type==XVWindow) {
			objects[i].pwindow->Unmap();
			objects[i].pwindow->Map();
		}

}

void func_grid_cancel(Widget aw, XtPointer client, XtPointer call)
{
	xvisGrid.Close();
}

//---------------------------------------------
// Local Stuff

void buildGridWindow()	
{
	xvisGrid.init("Grid Controls", "xvisGrid", xvisContext);
	xvisGrid.SetBackground("gray70");
 	xvisGrid.SetWindowResource(XtNiconPixmap, 
		xvisGrid.SetPixmapInfo(xvis_xpm, NULL));
	xvisGrid.SetWindowResource(XtNgeometry, (XtArgVal)"+250+220");

	xlab.init("X Spacing", xvisGrid);
	xlab.SetBackground("gray70");
	xlab.SetForeground("blue");
	xlab.SetDistance(10, 20);
	xlab.ChangeFont("*times-*-r-*-140*"); 
	xlab.SetBorderWidth(0);
	xlab.SetFixedPosition(TRUE);

	xval.init("AppName", xvisGrid, XawtextEdit, 20, 50);
	xval.SetDistance(90, 20);
	XtTranslations xval_trans=XtParseTranslationTable(
		"<Key>Return: select-all() \n\
		!Meta<Key> i: no-op()");
	xval.OverrideTranslations(xval_trans);
	xval.SetFixedPosition(TRUE);

	ylab.init("Y Spacing", xvisGrid);
	ylab.SetBackground("gray70");
	ylab.SetForeground("blue");
	ylab.SetDistance(10, 60);
	ylab.ChangeFont("*times-*-r-*-140*"); 
	ylab.SetBorderWidth(0);
	ylab.SetFixedPosition(TRUE);

	yval.init("yval", xvisGrid, XawtextEdit, 20, 50);
	yval.SetDistance(90, 60);
	XtTranslations yval_trans=XtParseTranslationTable(
		"<Key>Return: select-all() \n\
		!Meta<Key> i: no-op()");
	yval.OverrideTranslations(yval_trans);
	yval.SetFixedPosition(TRUE);

	labok.init("OK", xvisGrid, func_grid_ok);
	labok.SetDistance(15, 100);
	labok.ChangeFont("*times-*-r-*-140*"); 
	labok.SetWidth(75);
	labok.SetShadowWidth(4);
	labok.SetBackground("gray85");
	labok.SetFixedPosition(TRUE);
	labok.SetBeNiceToColormap(FALSE);

	labcancel.init("Cancel", xvisGrid, func_grid_cancel);
	labcancel.SetDistance(110, 100);
	labcancel.ChangeFont("*times-*-r-*-140*"); 
	labcancel.SetWidth(75);
	labcancel.SetShadowWidth(4);
	labcancel.SetBackground("gray85");
	labcancel.SetFixedPosition(TRUE);
	labcancel.SetBeNiceToColormap(FALSE);

}

void openGridWindow()
{
	char tempbuf[50];

	sprintf(tempbuf, "%d", gridX);
	xval.SetString(tempbuf);

	sprintf(tempbuf, "%d", gridY);
	yval.SetString(tempbuf);

	xvisGrid.Open();	
}

