
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	xvisTools segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Local Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>

// ---------------------------------------------
// Local Image files

#include "bitmaps/pointer.xbm"
#include "bitmaps/timer.xbm"
#include "bitmaps/bitmap.xbm"
#include "bitmaps/dropdown.xbm"
#include "bitmaps/toggle.xbm"
#include "bitmaps/vscroll.xbm"
#include "bitmaps/hscroll.xbm"
#include "bitmaps/panner.xbm"
#include "bitmaps/list.xbm"
#include "bitmaps/label.xbm"
#include "bitmaps/edit.xbm"
#include "bitmaps/repeater.xbm"
#include "bitmaps/button.xbm"
#include "bitmaps/box.xbm"
#include "bitmaps/form.xbm"
#include "bitmaps/filelist.xbm"
#include "bitmaps/dirlist.xbm"

// ---------------------------------------------
// Local Forward Function declarations


// ---------------------------------------------
// Local Variable & Data declarations


// ---------------------------------------------
// Local Callbacks

void func_toolselect(Widget aw, XtPointer client, XtPointer call)
{
	CurrentToolName= (char *) xPointer.GetCurrent();
	toollabel.SetLabel(CurrentToolName);
	toollabel.SetWidth(xvisTools.GetWidth());
	toollabel.SetBackground("SkyBlue");
}

// ---------------------------------------------
// Local Events


// ---------------------------------------------
// Local Functions

void buildToolsWindow()
{
	xvisTools.init("Tools", "xvisTools", xvisContext);
	xvisTools.SetBackground("gray70");
	xvisTools.SetWindowResource(XtNgeometry, (XtArgVal)"+40+220");
	xvisTools.SetWindowResource(XtNmaxWidth, 90);
	xvisTools.SetWindowResource(XtNmaxHeight, 359);
	xvisTools.SetWindowResource(XtNminWidth, 90);
	xvisTools.SetWindowResource(XtNminHeight, 359);
 	xvisTools.SetWindowResource(XtNiconPixmap, 
		xvisTools.SetPixmapInfo(xvis_xpm, NULL));

	toollabel.init(" ", xvisTools);
	toollabel.SetHorizDistance(1);
	toollabel.SetVertDistance(1);
	toollabel.SetFixedPosition(TRUE);
	toollabel.ChangeFont("*times-*-r-*-120*");

	xPointer.init("xPointer", xvisTools, func_toolselect, objectName[XVPointer]);
		xPointer.SetBackground("gray85");
		xPointer.SetBitmapInfo(pointer_bits, pointer_width, pointer_height, XtNbitmap);
		xPointer.SetDistance(1, 1);
		xPointer.SetRelVertical(toollabel);
		xPointer.SetFixedPosition(TRUE);
		xPointer.SetBeNiceToColormap(FALSE);
		xPointer.SetShadowWidth(4);
 
	xTimer.init("xTimer", xvisTools, func_toolselect, objectName[XVTimer]);
		xTimer.SetBackground("gray85");
		xTimer.SetBitmapInfo(timer_bits, timer_width, timer_height, XtNbitmap);
		xTimer.SetDistance(1, 1);
		xTimer.SetRelVertical(xPointer);
		xTimer.ChangeGroup(xPointer);
		xTimer.SetFixedPosition(TRUE);
		xTimer.SetBeNiceToColormap(FALSE);
		xTimer.SetShadowWidth(4);
 
	xButton.init("xButton", xvisTools, func_toolselect, objectName[XVButton]);
		xButton.SetBackground("gray85");
		xButton.SetBitmapInfo(button_bits, button_width, button_height, XtNbitmap);
		xButton.SetHorizDistance(1);
		xButton.SetVertDistance(1);
		xButton.SetRelVertical(xTimer);
		xButton.ChangeGroup(xPointer);
		xButton.SetFixedPosition(TRUE);
		xButton.SetBeNiceToColormap(FALSE);
		xButton.SetShadowWidth(4);
 
	xBitmap.init("xBitmap", xvisTools, func_toolselect, objectName[XVBitmap]);
		xBitmap.SetBackground("gray85");
		xBitmap.SetBitmapInfo(bitmap_bits, bitmap_width, bitmap_height, XtNbitmap);
		xBitmap.SetHorizDistance(1);
		xBitmap.SetVertDistance(1);
		xBitmap.SetRelVertical(xButton);
		xBitmap.ChangeGroup(xPointer);
		xBitmap.SetFixedPosition(TRUE);
		xBitmap.SetBeNiceToColormap(FALSE);
		xBitmap.SetShadowWidth(4);
 
	xDrop.init("xDrop", xvisTools, func_toolselect, objectName[XVDropDown]);
		xDrop.SetBackground("gray85");
		xDrop.SetBitmapInfo(dropdown_bits, dropdown_width, dropdown_height, XtNbitmap);
		xDrop.SetHorizDistance(1);
		xDrop.SetVertDistance(1);
		xDrop.SetRelVertical(xBitmap);
		xDrop.ChangeGroup(xPointer);
		xDrop.SetFixedPosition(TRUE);
		xDrop.SetBeNiceToColormap(FALSE);
		xDrop.SetShadowWidth(4);
 
	xPanner.init("xPanner", xvisTools, func_toolselect, objectName[XVPanner]);
		xPanner.SetBackground("gray85");
		xPanner.SetBitmapInfo(panner_bits, panner_width, panner_height, XtNbitmap);
		xPanner.SetHorizDistance(1);
		xPanner.SetVertDistance(1);
		xPanner.SetRelVertical(xDrop);
 		xPanner.ChangeGroup(xPointer);
		xPanner.SetFixedPosition(TRUE);
		xPanner.SetBeNiceToColormap(FALSE);
		xPanner.SetShadowWidth(4);

	xToggle.init("xToggle", xvisTools, func_toolselect, objectName[XVToggle]);
		xToggle.SetBackground("gray85");
		xToggle.SetBitmapInfo(toggle_bits, toggle_width, toggle_height, XtNbitmap);
		xToggle.SetHorizDistance(1);
		xToggle.SetVertDistance(1);
		xToggle.SetRelVertical(xPanner);
		xToggle.ChangeGroup(xPointer);
		xToggle.SetFixedPosition(TRUE);
		xToggle.SetBeNiceToColormap(FALSE);
		xToggle.SetShadowWidth(4);
 
	xVScroll.init("xVScroll", xvisTools, func_toolselect, objectName[XVVScroll]);
		xVScroll.SetBackground("gray85");
		xVScroll.SetBitmapInfo(vscroll_bits, vscroll_width, vscroll_height, XtNbitmap);
		xVScroll.SetHorizDistance(1);
		xVScroll.SetVertDistance(1);
		xVScroll.SetRelVertical(xToggle);
		xVScroll.ChangeGroup(xPointer);
		xVScroll.SetFixedPosition(TRUE);
		xVScroll.SetBeNiceToColormap(FALSE);
		xVScroll.SetShadowWidth(4);

	xFileList.init("xFileList", xvisTools, func_toolselect, objectName[XVFileList]);
		xFileList.SetBackground("gray85");
		xFileList.SetBitmapInfo(filelist_bits, filelist_width, filelist_height, XtNbitmap);
		xFileList.SetDistance(1, 1);
		xFileList.SetRelVertical(xVScroll);
		xFileList.ChangeGroup(xPointer);
		xFileList.SetFixedPosition(TRUE);
		xFileList.SetBeNiceToColormap(FALSE);
		xFileList.SetShadowWidth(4);
 
	xList.init("xList", xvisTools, func_toolselect, objectName[XVList]);
		xList.SetBackground("gray85");
		xList.SetBitmapInfo(list_bits, list_width, list_height, XtNbitmap);
		xList.SetHorizDistance(1);
		xList.SetVertDistance(1);
		xList.SetRelVertical(xPointer);
		xList.SetRelHorizontal(xPointer);
 		xList.ChangeGroup(xPointer);
		xList.SetFixedPosition(TRUE);
		xList.SetBeNiceToColormap(FALSE);
		xList.SetShadowWidth(4);

	xRepeater.init("xRepeater", xvisTools, func_toolselect, objectName[XVRepeater]);
		xRepeater.SetBackground("gray85");
		xRepeater.SetBitmapInfo(repeater_bits, repeater_width, repeater_height, XtNbitmap);
		xRepeater.SetHorizDistance(1);
		xRepeater.SetVertDistance(1);
		xRepeater.SetRelVertical(xList);
		xRepeater.SetRelHorizontal(xPointer);
 		xRepeater.ChangeGroup(xPointer);
		xRepeater.SetFixedPosition(TRUE);
		xRepeater.SetBeNiceToColormap(FALSE);
		xRepeater.SetShadowWidth(4);

	xLabel.init("xLabel", xvisTools, func_toolselect, objectName[XVLabel]);
		xLabel.SetBackground("gray85");
		xLabel.SetBitmapInfo(label_bits, label_width, label_height, XtNbitmap);
		xLabel.SetHorizDistance(1);
		xLabel.SetVertDistance(1);
		xLabel.SetRelVertical(xRepeater);
		xLabel.SetRelHorizontal(xPointer);
		xLabel.ChangeGroup(xPointer);
		xLabel.SetFixedPosition(TRUE);
		xLabel.SetBeNiceToColormap(FALSE);
		xLabel.SetShadowWidth(4);

	xEdit.init("xEdit", xvisTools, func_toolselect, objectName[XVEditField]);
		xEdit.SetBackground("gray85");
		xEdit.SetBitmapInfo(edit_bits, edit_width, edit_height, XtNbitmap);
		xEdit.SetHorizDistance(1);
		xEdit.SetVertDistance(1);
		xEdit.SetRelVertical(xLabel);
		xEdit.SetRelHorizontal(xPointer);
 		xEdit.ChangeGroup(xPointer);
		xEdit.SetFixedPosition(TRUE);
		xEdit.SetBeNiceToColormap(FALSE);
		xEdit.SetShadowWidth(4);

	xBox.init("xBox", xvisTools, func_toolselect, objectName[XVBox]);
		xBox.SetBackground("gray85");
		xBox.SetBitmapInfo(box_bits, box_width, box_height, XtNbitmap);
		xBox.SetHorizDistance(1);
		xBox.SetVertDistance(1);
		xBox.SetRelVertical(xEdit);
		xBox.SetRelHorizontal(xPointer);
 		xBox.ChangeGroup(xPointer);
		xBox.SetFixedPosition(TRUE);
		xBox.SetBeNiceToColormap(FALSE);
		xBox.SetShadowWidth(4);

	xForm.init("xForm", xvisTools, func_toolselect, objectName[XVForm]);
		xForm.SetBackground("gray85");
		xForm.SetBitmapInfo(form_bits, form_width, form_height, XtNbitmap);
		xForm.SetHorizDistance(1);
		xForm.SetVertDistance(1);
		xForm.SetRelVertical(xBox);
		xForm.SetRelHorizontal(xPointer);
 		xForm.ChangeGroup(xPointer);
		xForm.SetFixedPosition(TRUE);
		xForm.SetBeNiceToColormap(FALSE);
		xForm.SetShadowWidth(4);

	xHScroll.init("xHScroll", xvisTools, func_toolselect, objectName[XVHScroll]);
		xHScroll.SetBackground("gray85");
		xHScroll.SetBitmapInfo(hscroll_bits, hscroll_width, hscroll_height, XtNbitmap);
		xHScroll.SetHorizDistance(1);
		xHScroll.SetVertDistance(1);
		xHScroll.SetRelVertical(xForm);
		xHScroll.SetRelHorizontal(xPointer);
 		xHScroll.ChangeGroup(xPointer);
		xHScroll.SetFixedPosition(TRUE);
		xHScroll.SetBeNiceToColormap(FALSE);
		xHScroll.SetShadowWidth(4);

	xDirList.init("xDirList", xvisTools, func_toolselect, objectName[XVDirList]);
		xDirList.SetBackground("gray85");
		xDirList.SetBitmapInfo(dirlist_bits, dirlist_width, dirlist_height, XtNbitmap);
		xDirList.SetDistance(1, 1);
		xDirList.SetRelVertical(xHScroll);
		xDirList.SetRelHorizontal(xPointer);
		xDirList.ChangeGroup(xPointer);
		xDirList.SetFixedPosition(TRUE);
		xDirList.SetBeNiceToColormap(FALSE);
		xDirList.SetShadowWidth(4);
 
	xPointer.ChangeCurrent(objectName[XVPointer]);
	ToolsVisible=TRUE;	
}

// ------------------------------------
